try:
    from IPython.Debugger import Tracer
    debug = Tracer('Linux')
except:
    import pdb
    debug = pdb.set_trace

try:
    from IPython.ultraTB import FormattedTB
    trace = FormattedTB(mode='Verbose', color_scheme='Linux', call_pdb=0)
except:
    import traceback
    trace = traceback.print_exc

def profile(profiler):
    def wrapper(fn):
        def inner(*args, **kwargs):
            p.runcall(fn, *args, **kwargs)
        return inner
    return wrapper

def log_file(filelike):
    def log(msg, *args):
        if len(args):
            filelike.write(msg % args + '\n')
        else:
            filelike.write(msg + '\n')
    return log

